structure sub_catg =
    struct

	fun ant_direct arrows obj = 
	    List.map (fn (s,d)=> s) (List.filter (fn (s,d) => (FunCatg.equal_obj obj d)) arrows) 

	fun and_more arrows l =
	    List.map (fn (s,d)=> s) (List.filter (fn (s,d) => 
						  (List.length l < List.length (FunCatg.assertions s))
						  andalso
						  (Utils.setcont (l, (FunCatg.assertions s)))
						  ) arrows) 

	fun or_less arrows l =
	    List.map (fn (s,d)=> s) (List.filter (fn (s,d) => 
						  (List.length l > List.length (FunCatg.assertions d))
						  andalso
						  (Utils.setcont ((FunCatg.assertions d), l))
						  ) arrows) 

	fun all_arr arrows dst =
	    let
		fun arrs [] = []
		  | arrs objs = (arrs (ants arrows objs))@objs
	    in
		arrs [dst]
	    end    
	and
	    and_all arrows =
	    fn [] => []
	     | h::[] => (all_arr arrows (Catg.sing(h)))
	     | h::t => Utils.inter FunCatg.equal_obj (all_arr arrows (Catg.sing(h))) (and_all arrows t)
	and
	    ant arrows = fn 
	    obj as Catg.sing(a) => (ant_direct arrows obj)@(and_more arrows [a])
	  | obj as Catg.max(l) => (ant_direct arrows obj)@(or_less arrows l)
	  | Catg.min(l) => (and_more arrows l)@(and_all arrows l)
	  | _ => []
	and
	    ants arrows objs = 
	    List.concat (List.map (ant arrows) objs)
    
	fun find_arr arrows (src,dst) =
	    let
		fun arrs [] = false
		  | arrs objs = 
		    let
			val ant_objs = (ants arrows objs)
		    in
			if (List.exists (fn x => FunCatg.equal_obj src x) ant_objs) then
			    true
			else arrs ant_objs
		    end
	    in
		if (FunCatg.equal_obj src dst) then true 
		else arrs [dst]
	    end
	

	fun sub_catg (obj1,arr1) (obj2,arr2) =
	    List.all (find_arr arr2) arr1

    end




    